from typing import List

import pandas as pd
import math

from study2.s2_config import TRAINING_EFFECT_ORDER_RANGE


def convert_order_values(data_frame: pd.DataFrame, order_string: str) -> pd.DataFrame:
    if order_string not in ["sessionOrder", "backgroundOrder"]:
        return data_frame

    def order_change(row: pd.Series, order_str: str):
        offset = TRAINING_EFFECT_ORDER_RANGE / (2 if order_str == "backgroundOrder" else 1)
        max_b = 24 / (2 if order_str == "backgroundOrder" else 1)

        order = row[order_str]
        if 1 <= order <= offset:
            return "Start"
        elif offset < order <= offset * 2:
            return "Middle-1"
        elif offset * 2 < order <= offset * 3:
            return "Middle-2"
        elif offset * 3 < order <= max_b:
            return "End"
        else:
            return "Middle"

    data_frame[order_string+"Grouping"] = data_frame.apply(lambda row: order_change(row, order_string), axis=1)
    return data_frame
